// BeauGaugeExample016Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGaugeExample016.h"
#include "BeauGaugeExample016Dlg.h"
#include ".\beaugaugeexample016dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBeauGaugeExample016Dlg dialog



CBeauGaugeExample016Dlg::CBeauGaugeExample016Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeauGaugeExample016Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeExample016Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	for(int i = 0 ; i < 5 ; i++ )
	{
		DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL1 + i, m_gauge[i]);
	}	
}

BEGIN_MESSAGE_MAP(CBeauGaugeExample016Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CBeauGaugeExample016Dlg message handlers

BOOL CBeauGaugeExample016Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	this->SetTimer(1,30,NULL);
	this->SetTimer(2,600,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeExample016Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeExample016Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeExample016Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBeauGaugeExample016Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	this->KillTimer(1);
	this->KillTimer(2);
}

void CBeauGaugeExample016Dlg::OnTimer(UINT nIDEvent)
{
	static double f = 0;
	if(nIDEvent == 1)
	{
		m_gauge[0].SetValue(_T("Pointer1"), f);
		m_gauge[4].SetValue(_T("Pointer1"), f);

		f++;
		if (f > 100)
			f = 0;
	}

	static BOOL b = TRUE;
	if(nIDEvent == 2)
	{
		if (b)
		{
			m_gauge[3].SetValue(_T("ImageStateIndicator1"), 1);
		}
		else
		{
			m_gauge[3].SetValue(_T("ImageStateIndicator1"), 0);
		}

		b = !b;
	}

	CDialog::OnTimer(nIDEvent);
}
